codeforces 505C. Mr. Kitayuta, the Treasure Hunter (記憶化搜尋)
題目大意:有30000個島嶼從左到右排列,給你一個n一個d,n代表有n個寶石分別,接下來n行表示每個寶石分別在哪個島嶼上,d代表你第一次從0開始跳躍到的位置,以後你每次可以從你的位置跳躍l-1,l,l+1的距離。
解題思路,其實以前做過一個類似的,他跳躍的步數其實很小,解設每次跳一步加以來也是(n+1)×n/2 = 30000差不多250左右,也就是說每次他最多也就會跳出來250種情況,所以,我們可以開dp[30010][500]再加一個偏移,這樣記憶化搜尋每個點,類似於樹形dp從根節點找到一個最長的鏈,每次分三個叉,一個是l-1, l, l+1三個方向向下找。
The Shuseki Islands are an archipelago of 30001 small islands in the Yutampo Sea. The islands are evenly spaced along a line, numbered from 0 to 30000 from the west to the east. These islands are known to contain many treasures. There are n gems in the Shuseki Islands in total, and the i-th gem is located on island pi.
Mr. Kitayuta has just arrived at island 0. With his great jumping ability, he will repeatedly perform jumps between islands to the east according to the following process:
- First, he will jump from island 0 to island d.
- After that, he will continue jumping according to the following rule. Let l be the length of the previous jump, that is, if his previous jump was from island prev to island cur, let l = cur - prev. He will perform a jump of length l - 1, l or l + 1 to the east. That is, he will jump to island (cur + l - 1), (cur + l) or (cur + l + 1) (if they exist). The length of a jump must be positive, that is, he cannot perform a jump of length 0 when l = 1. If there is no valid destination, he will stop jumping.
Mr. Kitayuta will collect the gems on the islands visited during the process. Find the maximum number of gems that he can collect.
The first line of the input contains two space-separated integers n and d (1 ≤ n, d ≤ 30000), denoting the number of the gems in the Shuseki Islands and the length of the Mr. Kitayuta's first jump, respectively.
The next n lines describe the location of the gems. The i-th of them (1 ≤ i ≤ n) contains a integer pi (d ≤ p1 ≤ p2 ≤ ... ≤ pn ≤ 30000), denoting the number of the island that contains the i-th gem.
Print the maximum number of gems that Mr. Kitayuta can collect.
4 10 10 21 27 27
3
8 8 9 19 28 36 45 55 66 78
6
13 7 8 8 9 16 17 17 18 21 23 24 24 26 30
4
In the first sample, the optimal route is 0 → 10 (+1 gem) → 19 → 27 (+2 gems) → ...
In the second sample, the optimal route is 0 → 8 → 15 → 21 → 28 (+1 gem) → 36 (+1 gem) → 45 (+1 gem) → 55 (+1 gem) → 66 (+1 gem) → 78 (+1 gem) → ...
In the third sample, the optimal route is 0 → 7 → 13 → 18 (+1 gem) → 24 (+2 gems) → 30 (+1 gem) → ...
#include <algorithm>
#include <iostream>
#include <stdlib.h>
#include <string.h>
#include <iomanip>
#include <stdio.h>
#include <string>
#include <queue>
#include <cmath>
#include <stack>
#include <ctime>
#include <map>
#include <set>
#define eps 1e-9
///#define M 1000100
///#define LL __int64
#define LL long long
///#define INF 0x7ffffff
#define INF 0x3f3f3f3f
#define PI 3.1415926535898
#define zero(x) ((fabs(x)<eps)?0:x)
#define mod 1000000007
#define Read() freopen("autocomplete.in","r",stdin)
#define Write() freopen("autocomplete.out","w",stdout)
#define Cin() ios::sync_with_stdio(false)
using namespace std;
inline int read()
{
char ch;
bool flag = false;
int a = 0;
while(!((((ch = getchar()) >= '0') && (ch <= '9')) || (ch == '-')));
if(ch != '-')
{
a *= 10;
a += ch - '0';
}
else
{
flag = true;
}
while(((ch = getchar()) >= '0') && (ch <= '9'))
{
a *= 10;
a += ch - '0';
}
if(flag)
{
a = -a;
}
return a;
}
void write(int a)
{
if(a < 0)
{
putchar('-');
a = -a;
}
if(a >= 10)
{
write(a / 10);
}
putchar(a % 10 + '0');
}
const int maxn = 30010;
int dp[maxn][520];
int dx[] = {-1, 0, 1};
int Max;
int num[maxn];
int sum[maxn];
int d;
int dfs(int pos, int l)
{
int site = pos+l+d;
if(l+d < 1 || site > Max)
{
return 0;
}
if(dp[site][l+250] != -1) return dp[site][l+250];
if(l+d <= 2)
{
dp[site][l+250] = sum[site];
return dp[site][l+250];
}
if(l+d == 3)
{
dp[site][l+250] = sum[site+2]+num[site];
return dp[site][l+250];
}
int sum = 0;
for(int i = 0; i < 3; i++)
{
int xl = l+dx[i];
sum = max(sum, dfs(site, xl));
}
sum += num[site];
return dp[site][l+250] = sum;
}
int main()
{
int n;
cin >>n>>d;
memset(num, 0, sizeof(num));
memset(dp, -1, sizeof(dp));
memset(sum, 0, sizeof(sum));
int x;
Max = 0;
for(int i = 0; i < n; i++)
{
scanf("%d",&x);
Max = max(x, Max);
num[x]++;
}
for(int i = Max; i >= 1; i--) sum[i] = sum[i+1]+num[i];
x = dfs(0, 0);
cout<<x<<endl;
return 0;
}
相關文章
- Codeforces 505C Mr. Kitayuta, the Treasure Hunter:dp【考慮可用範圍】
- Codeforces 900D Unusual Sequences:記憶化搜尋
- 記憶化搜尋
- C++記憶化搜尋C++
- Codeforces 148D Bag of mice:概率dp 記憶化搜尋
- Codeforces Round #390 (Div. 2)(A,B,C(記憶化搜尋),D(貪心,優先佇列))佇列
- Mr. Kitayuta‘s Technology CodeForces - 505D(並查集+拓撲排序或dfs找環) 題解並查集排序
- Codeforces Round #689 (Div. 2, based on Zed Code Competition)-B. Find the Spruce(DFS+記憶化搜尋)Zed
- POJ 1579-Function Run Fun(記憶化搜尋-遞迴)Function遞迴
- 【leetcode 1510 石子游戲】【記憶化搜尋】LeetCode
- C - Digital Path 計蒜客 - 42397(dp記憶化搜尋)Git
- 組合數的計算(利用楊輝三角/記憶化搜尋)
- ES 筆記十七:結構化搜尋筆記
- WeetCode3 暴力遞迴->記憶化搜尋->動態規劃遞迴動態規劃
- poj1179 區間dp(記憶化搜尋寫法)有巨坑!
- 一類適合記憶化搜尋的區間dp
- POJ 2311-Cutting Game(Nim博弈-sg函式/記憶化搜尋)GAM函式
- 【leetcode 3149. 找出分數最低的排列】記憶化搜尋LeetCode
- 搜尋引擎優化(SEO)優化
- solr搜尋分詞優化Solr分詞優化
- 微信全文搜尋優化之路優化
- 搜尋結果頁優化優化
- Google的個性化搜尋Go
- 【記憶優化搜尋/dp】HDU - 6415 - 杭電多校第九場 - Rikka with Nash Equilibrium優化UI
- BZOJ 1048: [HAOI2007]分割矩陣 記憶化搜尋,二維字首和矩陣
- 折半搜尋學習筆記筆記
- 【Leetcode】1340. Jump Game V 【動態規劃/記憶性搜尋】LeetCodeGAM動態規劃
- Android本地搜尋最佳化Android
- 海量資料搜尋---搜尋引擎
- 淺談用“搜尋大法”來索取記憶體註冊碼 (4千字)記憶體
- 搜尋引擎-03-搜尋引擎原理
- 機票垂直搜尋引擎之效能優化優化
- 搜尋引擎優化內容及方法優化
- RobotFramework自動化3-搜尋案例Framework
- 任意列搜尋之列儲存優化優化
- Meta 標籤與搜尋引擎優化優化
- 網站搜尋引擎優化問題網站優化
- 搜尋元件最佳化 - Command ⌘K元件